/*
 ============================================================================
 Name		 : SocketsWriter.cpp
 Copyright   : Symbian Academy, 2007
 Description : Responsible for sending data through the socket to the server.
 ============================================================================
 */

#include "SocketsWriter.h"

CSocketsWriter::CSocketsWriter(RSocket* aSocket, MSocketsNotifier* aNotifier) :
	CActive( EPriorityStandard), // Standard priority
			iSocket(aSocket), iNotifier(aNotifier)
	{
	}

CSocketsWriter* CSocketsWriter::NewLC(RSocket* aSocket,
		MSocketsNotifier* aNotifier)
	{
	CSocketsWriter* self = new ( ELeave ) CSocketsWriter(aSocket, aNotifier);
	CleanupStack::PushL ( self);
	self->ConstructL ();
	return self;
	}

CSocketsWriter* CSocketsWriter::NewL(RSocket* aSocket,
		MSocketsNotifier* aNotifier)
	{
	CSocketsWriter* self = CSocketsWriter::NewLC (aSocket, aNotifier);
	CleanupStack::Pop (); // self;
	return self;
	}

void CSocketsWriter::ConstructL()
	{
	// Edit 20: Add this class to the active scheduler

	}

CSocketsWriter::~CSocketsWriter()
	{
	// Edit 21: Cancel any request, if outstanding

	// Edit 22: Close / delete the temponary buffer

	}

void CSocketsWriter::DoCancel()
	{
	// Edit 23: Cancel the sending process of the socket
	//          (see the SDK help for the appropriate method)
	
	}

void CSocketsWriter::IssueSend( const TDesC8& aData)
	{
	// Edit 24: Take care of the situation if another request is
	//          already active - e.g. by canceling it or by ignoring
	//          the new request.

	// Edit 25: Create a local copy of the message from the
	//          argument. If using an RBuf, make sure to free
	//          the memory first before creating a new buffer based
	//          on the new data. If you are reusing the existing memory,
	//          make sure it's large enough.

	
	// Edit 26: Write the data to the socket

	// Edit 27: Set this AO to active

	}

void CSocketsWriter::RunL()
	{
	if ( iStatus != KErrNone)
		{
		_LIT(KSocketsWriterError, "Error: Sockets write");
		if ( iNotifier)
			{
			iNotifier->NotifyInfo (iStatus.Int (), KSocketsWriterError);
			}
		}
	}

